﻿using System;
using System.ComponentModel.Composition;
using System.Linq;
using System.Windows.Controls;
using Microsoft.Practices.Prism.Modularity;
using Microsoft.Practices.Prism.Regions;

namespace DiagramsAndPrism
{
	[Export]
	public partial class Shell : UserControl
	{
		[Import]
		public IRegionManager TheRegionManager { private get; set; }

		private IModuleManager theModuleManager;

		[ImportingConstructor]
		public Shell([Import]IModuleManager moduleManager)
		{
			InitializeComponent();

			this.theModuleManager = moduleManager;
		}

		private void DebugButton_Click(object sender, System.Windows.RoutedEventArgs e)
		{
			var items = this.TheDiagram.Items;
			if (items.Count > 0)
			{ 
				var item = items[0];
			}
		}
		private void LoadModuleButton_Click(object sender, System.Windows.RoutedEventArgs e)
		{
			this.theModuleManager.LoadModule("Module1Impl");
		}

		private void InjectViewButton_Click(object sender, System.Windows.RoutedEventArgs e)
		{
			IRegion region = this.TheRegionManager.Regions["DiagramRegion"];

			region.Add(new Button
			{
				Content = "Injected View",
				FontSize = 20,
				Margin = new System.Windows.Thickness(10)
			});
		}
	}
}
