﻿using System;
using System.ComponentModel.Composition.Hosting;
using System.Windows;
using Microsoft.Practices.Prism.MefExtensions;
using Microsoft.Practices.Prism.Modularity;
using Microsoft.Practices.Prism.Regions;
using Telerik.Windows.Controls;

namespace DiagramsAndPrism
{
	public class TheBootstrapper : MefBootstrapper
	{
		protected override void InitializeShell()
		{
			base.InitializeShell();

			Application.Current.RootVisual = (UIElement)Shell;
		}

		protected override RegionAdapterMappings ConfigureRegionAdapterMappings()
		{
			RegionAdapterMappings mappings = base.ConfigureRegionAdapterMappings();
			mappings.RegisterMapping(typeof(RadDiagram), this.Container.GetExportedValue<RadDiagramRegionAdapter>());
			return mappings;
		}

		protected override DependencyObject CreateShell()
		{
			return Container.GetExportedValue<Shell>();
		}

		protected override void ConfigureAggregateCatalog()
		{
			base.ConfigureAggregateCatalog();
			this.AggregateCatalog.Catalogs.Add(new AssemblyCatalog(this.GetType().Assembly));
		}

		protected override IModuleCatalog CreateModuleCatalog()
		{
			ModuleCatalog moduleCatalog = new ModuleCatalog();

			moduleCatalog.AddModule
			(
				new ModuleInfo
				{
					InitializationMode = InitializationMode.WhenAvailable,
					Ref = "Module0.xap",
					ModuleName = "Module0Impl",
					ModuleType = "Module0.Module0Impl, Module0, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null"
				}
			);

			moduleCatalog.AddModule
			(
				new ModuleInfo
				{
					InitializationMode = InitializationMode.OnDemand,
					Ref = "Module1.xap",
					ModuleName = "Module1Impl",
					ModuleType = "Module1.Module1Impl, Module1, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null"
				}
			);

			return moduleCatalog;
		}
	}
}
